- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Types | Public Member Functions
BucketHeap< IM, MIN > Class Template Reference
Heap Structures

## Detailed Description

### template<typename IM, bool MIN = true>
class lemon::BucketHeap< IM, MIN >

This class implements the bucket heap data structure. It practically conforms to the heap concept, but it has some limitations.

The bucket heap is a very simple structure. It can store only `int` priorities and it maintains a list of items for each priority in the range `[0..C)`. So it should only be used when the priorities are small. It is not intended to use as a Dijkstra heap.

Template Parameters

  IM | A read-writable item map with `int` values, used internally to handle the cross references.
  MIN | Indicate if the heap is a min-heap or a max-heap. The default is min-heap. If this parameter is set to `false`, then the comparison is reversed, so the top(), prio() and pop() functions deal with the item having maximum priority instead of the minimum.

See Also
  SimpleBucketHeap

`#include <lemon/bucket_heap.h>`

## Public Types
enum | State { IN_HEAP = 0, PRE_HEAP = -1, POST_HEAP = -2 }
| Type to represent the states of the items. More...
typedef IM | ItemIntMap
| Type of the item-int map.
typedef int | Prio
| Type of the priorities.
typedef ItemIntMap::Key | Item
| Type of the items stored in the heap.
typedef std::pair< Item, Prio > | Pair
| Type of the item-priority pairs.

## Public Member Functions
| BucketHeap (ItemIntMap &map)
| Constructor. More...
int | size () const
| The number of items stored in the heap. More...
bool | empty () const
| Check if the heap is empty. More...
void | clear ()
| Make the heap empty. More...
void | push (const Pair &p)
| Insert a pair of item and priority into the heap. More...
void | push (const Item &i, const Prio &p)
| Insert an item into the heap with the given priority. More...
Item | top () const
| Return the item having minimum priority. More...
Prio | prio () const
| The minimum priority. More...
void | pop ()
| Remove the item having minimum priority. More...
void | erase (const Item &i)
| Remove the given item from the heap. More...
Prio | operator[] (const Item &i) const
| The priority of the given item. More...
void | set (const Item &i, const Prio &p)
| Set the priority of an item or insert it, if it is not stored in the heap. More...
void | decrease (const Item &i, const Prio &p)
| Decrease the priority of an item to the given value. More...
void | increase (const Item &i, const Prio &p)
| Increase the priority of an item to the given value. More...
State | state (const Item &i) const
| Return the state of an item. More...
void | state (const Item &i, State st)
| Set the state of an item in the heap. More...

## Member Enumeration Documentation

enum State

Each item has a state associated to it. It can be "in heap", "pre-heap" or "post-heap". The latter two are indifferent from the heap's point of view, but may be useful to the user.

The item-int map must be initialized in such way that it assigns `PRE_HEAP` (`-1`) to any element to be put in the heap.

Enumerator
IN_HEAP | = 0.
PRE_HEAP | = -1.
POST_HEAP | = -2.

## Constructor & Destructor Documentation

BucketHeap | ( | ItemIntMap & | map | ) |
| inline explicit

Constructor.

Parameters

  map | A map that assigns `int` values to the items. It is used internally to handle the cross references. The assigned value must be `PRE_HEAP` (`-1`) for each item.

## Member Function Documentation

int size | ( |  | ) | const
| inline

This function returns the number of items stored in the heap.

bool empty | ( |  | ) | const
| inline

This function returns `true` if the heap is empty.

void clear | ( |  | ) |
| inline

This functon makes the heap empty. It does not change the cross reference map. If you want to reuse a heap that is not surely empty, you should first clear it and then you should set the cross reference map to `PRE_HEAP` for each item.

void push | ( | const Pair & | p | ) |
| inline

This function inserts `p.first` to the heap with priority `p.second`.

Parameters

  p | The pair to insert.

Precondition
  `p.first` must not be stored in the heap.

void push | ( | const Item & | i,
|  | const Prio & | p
| ) |  |
| inline

This function inserts the given item into the heap with the given priority.

Parameters

  i | The item to insert.
  p | The priority of the item.

Precondition
  i must not be stored in the heap.

Item top | ( |  | ) | const
| inline

This function returns the item having minimum priority.

Precondition
  The heap must be non-empty.

Prio prio | ( |  | ) | const
| inline

This function returns the minimum priority.

Precondition
  The heap must be non-empty.

void pop | ( |  | ) |
| inline

This function removes the item having minimum priority.

Precondition
  The heap must be non-empty.

void erase | ( | const Item & | i | ) |
| inline

This function removes the given item from the heap if it is already stored.

Parameters

  i | The item to delete.

Precondition
  i must be in the heap.

Prio operator[] | ( | const Item & | i | ) | const
| inline

This function returns the priority of the given item.

Parameters

  i | The item.

Precondition
  i must be in the heap.

void set | ( | const Item & | i,
|  | const Prio & | p
| ) |  |
| inline

This method sets the priority of the given item if it is already stored in the heap. Otherwise it inserts the given item into the heap with the given priority.

Parameters

  i | The item.
  p | The priority.

void decrease | ( | const Item & | i,
|  | const Prio & | p
| ) |  |
| inline

This function decreases the priority of an item to the given value.

Parameters

  i | The item.
  p | The priority.

Precondition
  i must be stored in the heap with priority at least p.

void increase | ( | const Item & | i,
|  | const Prio & | p
| ) |  |
| inline

This function increases the priority of an item to the given value.

Parameters

  i | The item.
  p | The priority.

Precondition
  i must be stored in the heap with priority at most p.

State state | ( | const Item & | i | ) | const
| inline

This method returns `PRE_HEAP` if the given item has never been in the heap, `IN_HEAP` if it is in the heap at the moment, and `POST_HEAP` otherwise. In the latter case it is possible that the item will get back to the heap again.

Parameters

  i | The item.

void state | ( | const Item & | i,
|  | State | st
| ) |  |
| inline

This function sets the state of the given item in the heap. It can be used to manually clear the heap when it is important to achive better time complexity.

Parameters

  i | The item.
  st | The state. It should not be `IN_HEAP`.